// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from PaymentDeviceState.djinni

#pragma once

#include <functional>
#include <string>

namespace verifone_sdk {

enum class PaymentDeviceState : int {
    /** The device is connected and available for operation. */
    AVAILABLE,
    /**
     * Received when the device is shutting down, and then remembered until the device becomes 
     * active again.
     */
    SHUTDOWN,
    /**
     * The device is starting a maintenance cycle and cannot be used. The device might also restart
     * during this time, or perform other activities that generate other events.
     */
    BEGIN_MAINTENANCE,
    /** The device has completed the maintenance cycle. */
    END_MAINTENANCE,
    /** The device must perform maintenance as soon as possible. */
    MAINTENANCE_REQUIRED,
    /** The device is able to be reached but it cannot perform any operations due to some mulfunction. */
    OUT_OF_ORDER,
    /**
     * The device has just been found during discovery, but more information about the state and the 
     * device is not available because the device has not been paired.
     */
    DISCOVERED,
    /**
     * Returned when the device is remembered but the current state cannot be ascertained. For 
     * example, this can be returned when a device has shutdown and is now not available.
     */
    UNKNOWN,
};

constexpr std::string_view toString(const PaymentDeviceState& arg) {
    switch(arg) {
        case PaymentDeviceState::AVAILABLE: return "AVAILABLE";
        case PaymentDeviceState::SHUTDOWN: return "SHUTDOWN";
        case PaymentDeviceState::BEGIN_MAINTENANCE: return "BEGIN_MAINTENANCE";
        case PaymentDeviceState::END_MAINTENANCE: return "END_MAINTENANCE";
        case PaymentDeviceState::MAINTENANCE_REQUIRED: return "MAINTENANCE_REQUIRED";
        case PaymentDeviceState::OUT_OF_ORDER: return "OUT_OF_ORDER";
        case PaymentDeviceState::DISCOVERED: return "DISCOVERED";
        case PaymentDeviceState::UNKNOWN: return "UNKNOWN";
        default: return "PaymentDeviceState enum value not supported";
    }
}

}  // namespace verifone_sdk

namespace std {

template <>
struct hash<::verifone_sdk::PaymentDeviceState> {
    size_t operator()(::verifone_sdk::PaymentDeviceState type) const {
        return std::hash<int>()(static_cast<int>(type));
    }
};

}  // namespace std
